stages:
  - build_image
  - test

variables:
  IMAGE_NAME: ${CI_REGISTRY_IMAGE}/testing

#########################################################
#
#   SETUP
#
#########################################################

.set_tag: &set_tag
  before_script:
    - case ${CI_COMMIT_REF_NAME} in
      master) export TAG=stable;;
      *) export TAG=${CI_COMMIT_REF_NAME};;
      esac

#########################################################
#
#   TEST IMAGE
#
#########################################################

build_test_image:
  <<: *set_tag
  tags: [docker, linux]
  image: docker:stable
  stage: build_image
  services:
    - docker:dind
  script:
    - docker login -u ${CI_REGISTRY_USER} -p ${CI_REGISTRY_PASSWORD} ${CI_REGISTRY}
    - docker pull ${IMAGE_NAME}:latest || true
    - docker build --cache-from ${IMAGE_NAME}:latest -t ${IMAGE_NAME}:${TAG} -t ${IMAGE_NAME}:latest .
    - docker push ${IMAGE_NAME}:${TAG}
    - docker push ${IMAGE_NAME}:latest

#########################################################
#
#   TESTS
#
#########################################################

.prep_test: &prep_test
  image: ${IMAGE_NAME}:latest
  stage: test
  script:
    - export PKG_DIR=`python -c "import site; print(site.getsitepackages()[0])"`
    - export MIN_COV=95
    - py.test tests/${TO_TEST}
      --cov=${PKG_DIR}/backtest/${TO_TEST}
      --cov-report term-missing
      --cov-fail-under=${MIN_COV}
  coverage: '/TOTAL.*\s+(\d+%)$/'

run_core_tests:
  variables:
    TO_TEST: core
  <<: *set_tag
  <<: *prep_test
